﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",

    "dojo/dom-class",

    "dijit/Tree",
    "dijit/focus",
    "dijit/_HasDropDown",

    "epi-cms/widget/PersonalizationSelector",

    "epi-cms/dgrid/formatters",

    "./_ContentAreaTreeNodeMixin",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.blockcontextmenu",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize",
    "dojo/text!./templates/_BlockTreeNode.html"
], function(declare, lang, keys, domClass, Tree, focusUtil, _HasDropDown, PersonalizationSelector, formatters, _ContentAreaTreeNodeMixin, tooltip, resources, template){

    return declare([Tree._TreeNode, _ContentAreaTreeNodeMixin, _HasDropDown], {
        // tags:
        //      internal
        
        templateString: template,

        _contextMenuClass: 'epi-iconContextMenu',
        isExpandable: false,
        dropDownPosition: ["before"],
        resources: lang.mixin(tooltip, resources),

        buildRendering: function() {
            this.inherited(arguments);

            this.dropDown = new PersonalizationSelector({ model: this.item });
            this.own(this.dropDown);
            this.aroundNode = this.domNode;
            this.set("readOnly", this.item.readOnly);

            domClass.add(this.domNode, "epi-tree-mngr--block");

            var node = this.rolesNode;

            // Get the icon from the type descriptor
            var icon = formatters.contentIcon(this.item.typeIdentifier);
            domClass.add(this.iconNode, icon);

            node.innerHTML = this.item.get("rolesString");
            this.own(this.item.watch("rolesString", lang.hitch(this, function(property, oldValue, newValue) {
                node.innerHTML = newValue;
            })));

            this.own(this.item.watch("readOnly", lang.hitch(this, function() {
                this.set("readOnly", this.item.readOnly);
            })));
        },

        setSelected: function(selected, internalSelect) {
            this.inherited(arguments);

            this.item.set("selected", selected);

            domClass.toggle(this.iconNodeMenu, this._contextMenuClass, selected);
        },

        showPersonalizationSelector: function () {
            if(this.readOnly) {
                return;
            }

            this.item.set("ensurePersonalization", false);

            focusUtil.focus(this.labelNode);

            this.loadAndOpenDropDown();
        },

        focus: function() {
            // summary:
            //      We need this method because _HasDropDown calls focus when toggling the dropdown
            this.labelNode.focus();
        },

        _onKey: function(/*Event*/ e) {
            // summary:
            //      We need to override the default behaviour otherwise the dropdown will popup
            //      when we click the downarrow on the tree node
            if(this.dropDown && this._opened && e.keyCode == keys.ESCAPE) {
                this.closeDropDown();
            }
        },

        _onKeyUp: function(){

        }
    });
});