define([
    "dojo/_base/declare",
// Resources
    "epi/i18n!epi/nls/episerver.cms.components.project.command.removeproject",
// Parent class
    "./_ProjectCommand"
], function(
    declare,
// Resources
    res,
// Parent class
    _ProjectCommand
) {

    return declare([_ProjectCommand], {

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        // store: [public] Store
        //      The store from which projects will be removed.
        store: null,

        iconClass: "epi-iconTrash",

        _execute: function() {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected

            var model = this.model;

            this.store.remove(model.selectedProject.id).then(
                function() {model.set("selectedProject", null); },
                function(ex) { console.error("Could not remove project: ", model.selectedProject.id, ex); }
            );
        },

        _setCanExecute: function() {
            // The command shouldn't be executable if a project is not selected.
            this.set("canExecute", !!this.model.selectedProject);
        }
    });
});
