define([
    "dojo/_base/declare",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.sortprojectitems",
    // Parent class
    "epi/shell/command/OptionCommand"
], function (
    declare,
    // Resources
    localizations,
    // Parent class
    OptionCommand
) {

    return declare([OptionCommand], {

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.label,

        // options: [readonly] Array
        //      An array of options objects that can be selected.
        options: null,

        // property: [readonly] String
        //      The name of the property on the model that will be set with the selected value on execute.
        property: "projectItemSortOrder",

        constructor: function () {
            this.options = [
                { label: localizations.nameascending,      key: "+Name",           value: [{ attribute: "Name", descending: false }]},
                { label: localizations.namedescending,     key: "-Name",           value: [{ attribute: "Name", descending: true } ]},
                { label: localizations.type,               key: "+TypeIdentifier", value: [{ attribute: "TypeIdentifier", descending: false }, { attribute: "Name", descending: false }]},
                { label: localizations.modifieddescending, key: "-DateModified",   value: [{ attribute: "DateModified", descending: true }, { attribute: "Name", descending: false }]},
                { label: localizations.modifiedascending,  key: "+DateModified",   value: [{ attribute: "DateModified", descending: false }, { attribute: "Name", descending: false }]}
            ];
        }
    });
});
