﻿define([
// Dojo
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/html",

// Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

// EPi CMS
    "epi-cms/_ContentContextMixin",
    "epi-cms/component/ContentQueryGrid",
    "dojo/text!./templates/ContentListing.html"
], function (
// Dojo
    dojo,
    declare,
    Deferred,
    html,

// Dijit
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

// EPi CMS
    _ContentContextMixin,
    ContentQueryGrid,
    template
) {

return declare("epi.cms.widget.ContentListing", [_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ContentContextMixin], {
        // summary: 
        //      This component enabled searching of content where the results will be displayed in a grid.
        //
        // tags:
        //      internal

        templateString: template,

        startup: function () {

            this.inherited(arguments);

            Deferred.when(this.getCurrentContext(), dojo.hitch(this, function (context) {
                this.contextChanged(context);
            }));
        },

        contentContextChanged: function (context, callerData, request) {

            html.set(this.header, context.name);
            this.contentQuery.set("queryParameters", { referenceId: context.id });
            this.contentQuery.set("queryName", "getchildren");
        }
    });
});