﻿define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/_base/array",
        "dojo/dom-style",
        "dojo/topic",

        "epi/dependency",

        "epi/shell/widget/ExpandoButton"
],
function (
    declare,
    lang,
    array,
    domStyle,
    topic,

    dependency,

    ExpandoButton) {
    return declare([ExpandoButton], {
        // tags:
        //      internal
        
        _toggleStateInitialized: null,

        postCreate: function () {
            this.inherited(arguments);

            //We need to get the view settings manager to figure out if the button should be expanded
            var viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");
            var setting = array.filter(viewSettingsManager.viewSettingsHashValue, function (item) {
                return item.type == "active";
            })[0];

            this.isExpand = setting ? setting.id === "true" : false;
            
            // Expand and calculate width of expando button
            array.forEach(this.containerNode.getChildren(), lang.hitch(this, function (child) {
                this.connect(child.childWidget, "onResize", "_onChildResize");
            }));
        },

        onChange: function (value) {
            if (this._toggleStateInitialized) {
                topic.publish("/epi/cms/action/eyetoggle", value);
                return;
            } 

            this._toggleStateInitialized = true;
        },

        _onChildResize: function () {
            // summary
            //      Calculate width of expando button
            // tags
            //      Private

            if (this.isExpanded()) {
                this._expand();
            }
        }
    });
});