﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/when",
    // epi
    "epi/shell/widget/ContextMenu",
    // epi-cms
    "./_GridWidgetBase"
], function (
    // Dojo
    declare,
    lang,
    domClass,
    when,
    //epi
    ContextMenu,
    // epi-cms
    _GridWidgetBase) {
    return declare([_GridWidgetBase], {
        // tags:
        //      internal
        
        storeKeyName: "epi.cms.content.search",

        trackActiveItem: false,

        gridAttachNode: null,

        // contextChangeEvent: [public] String
        //      Configure double click on a row to cause a context change.
        contextChangeEvent: "dblclick",

        postMixInProperties: function () {
            this.inherited(arguments);
            this.model = this.model || this.createModel();
        },

        postCreate: function () {
            // summary:
            //      Construct the UI for this widget.
            // tags:
            //      protected

            this.inherited(arguments);
            this.createList();
        },

        createModel: function () {
            // summary:
            //      Override to construct the default model for the list and context menu.
            // tags:
            //      protected
        },

        createList: function () {
            // summary:
            //      Creates the list for this widget.
            // tags:
            //      protected

            var settings = this.getListSettings();
            settings = lang.mixin(settings, this.defaultGridMixin);
            this.grid = new this._gridClass(settings, this.gridAttachNode || this.domNode);
            var hasModelWithCommands = this.model && this.model.commands && this.model.commands.length > 0;
            if (hasModelWithCommands) {
                this.grid.contextMenu.addProvider(this.model);
            }
            if (this.contextMenu) {
                this.grid.contextMenu = this.contextMenu;
            }

            this.own(this.grid);
            this.setupEvents();
        },

        getListSettings: function () {
            // summary:
            //      Override to specify the settings used to create the list.
            // tags:
            //      protected

            return {};
        },

        setupEvents: function () {
            // summary:
            //      Initialization of events on the list.
            // tags:
            //      protected, extension
        },

        onContextChanged: function () {
            //Disable default triggering of fetchData.
        },

        _onSelect: function (e) {

            when(this.getCurrentContext(), lang.hitch(this, function (currentContext) {

                var grid = this.grid;
                var model = {
                    contextId: currentContext.id,
                    data: []
                };

                if (this.model) {
                    for (var id in grid.selection) {
                        if (grid.selection[id]) {
                            var row = grid.row(id);
                            model.data.push(row.data);
                        }
                    }

                    this.model.set("model", model);
                }
            }));
        }
    });
});