﻿define([
// dojo
    "dojo/_base/declare",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/string",

// dijit
    "dijit/Tree",
    "dijit/_TemplatedMixin",
// dojox
    "dojox/html/ellipsis",
// epi
    "epi-cms/widget/_ContentTreeNodeMixin",
// template
    "dojo/text!./templates/_ContentTreeNode.html"
],

function (
// dojo
    declare,
    domClass,
    domConstruct,
    string,

// dijit
    Tree,
    _TemplatedMixin,
// dojox
    htmlEllipsis,
// epi
    _ContentTreeNodeMixin,
// template
    templateString
) {

    return declare([Tree._TreeNode, _TemplatedMixin, _ContentTreeNodeMixin], {
        // summary:
        //      A customized treenode for page tree
        // description:
        //      Redefine template string. Use <a> tag to be able to drag in IE
        // tags:
        //      internal

        templateString: templateString,

        buildRendering: function () {
            this.inherited(arguments);

            domClass.add(this.labelNode, "dojoxEllipsis");
        },

        _setItemAttr: function (item) {

            this._set("item", item);
            this.set("dndData", item);

            if (item && item.thumbnailUrl) {
                var image = domConstruct.create("img", {
                    src: item.thumbnailUrl + string.substitute("?${0}", [new Date().getTime()]),
                    "class": "epi-thumbnail"
                });
                this.thumbnailNode.appendChild(image);
                domClass.add(this.contentNode, "epi-mediaContent");
            }

            this.inherited(arguments);
        }

    });

});