﻿define([
//dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
//dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_Contained",
//epi
    "epi/string",
//resources
    "dojo/text!./templates/_HyperLinkFieldItem.html"
],
function (
//dojo
    declare,
    lang,
//dijit
    _Widget,
    _TemplatedMixin,
    _Contained,
//epi
    epiString,
//resources
    template
    ) {
    return declare([_Widget, _Contained, _TemplatedMixin], {
        // tags:
        //      internal
        
        templateString: template,

        // Represents widget to input link value
        inputWidget: null,

        inputWidgetCtor: null,

        // Settings for child widget
        settings: [],

        _inputWidgetNode: null,


        buildRendering: function() {
            this.inherited(arguments);

            var settings = lang.mixin(this.settings, {value: this.get("value") || null});

            this.own(this.inputWidget = new this.inputWidgetCtor(settings, this._inputWidgetNode));
        },

        startup: function() {
            this.inherited(arguments);

            this.inputWidget.startup();
        },

        _onRadioButtonChange: function (evt) {
            this.onRadioButtonChange(this, evt);
        },

        onRadioButtonChange: function (target, evt) {
            // trigger radio button change value event
        },

        validate: function () {
            return this.inputWidget ? this.inputWidget.validate() : false;
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            if (this.inputWidget) {
                this.inputWidget.set("value", value);
            }
        },

        _getValueAttr: function () {
            if(this._started && this.inputWidget) {
                return this.inputWidget.get("value");
            }

            return this.value;
        },

        _setRequiredAttr: function (val) {
            this._set("required", val);
            if (this.inputWidget) {
                this.inputWidget.set("required", val);
            }
        },

        _setSelectedAttr: function (value) {
            this._set("selected", value);
            if (this.inputWidget) {
                this.inputWidget.set("disabled", !value);

                if(!value) {
                    this.inputWidget.set("state", "");
                }
            }

            this.radioNode.checked =  value;
        },

        _getSelectedAttr: function () {
            return this.radioNode.checked;
        },

        _setShowAllLanguagesAttr: function (val) {
            this._set("showAllLanguages", val);
            if (this.inputWidget) {
                this.inputWidget.set("showAllLanguages", val);
            }
        },

        focus: function () {
            if (this.inputWidget) {
                this.inputWidget.focus();
            }
        }
    });
});