﻿define([
// Dojo
    "dojo/_base/lang",
    "dojo/_base/Deferred",

// EPi Framework
    "epi/string",

    "epi-cms/widget/overlay/Property"
    ],

    function (
// Dojo
    lang,
    Deferred,

// EPi Framework
    epiString
) {
    return {
        // tags:
        //      internal

        defaultType: "epi-cms/widget/overlay/Property",

        create: function (editableNode) {
            var createOverlayDeferred = new Deferred();
            var customType = editableNode.property.metadata.overlaySettings && editableNode.property.metadata.overlaySettings.customType;

            var property = editableNode.property,
                overlayType = epiString.slashName(customType || this.defaultType);

            require([overlayType], lang.hitch(this, function (overlayClass) {
                var settings = lang.mixin(
                    {
                        name: property.name,
                        contentModel: property.contentModel,
                        displayName: property.metadata.displayName,
                        disabled: editableNode.disabled,
                        sourceItemNode: editableNode.node
                    },
                    property.overlayParams);

                var overlay = new overlayClass(settings);
                createOverlayDeferred.resolve(overlay);
            }));

            return createOverlayDeferred;
        }
    };
});