﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/io-query",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/when",
//epi
    "epi/string",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/_StatefulGetterSetterMixin",
    "epi-cms/core/PermanentLinkHelper"

], function (
// dojo
    array,
    declare,
    lang,
    Stateful,
    ioQuery,
    domStyle,
    domConstruct,
    when,
//epi
    epiString,
    TypeDescriptorManager,
    _StatefulGetterSetterMixin,
    PermanentLinkHelper

) {

    return declare([Stateful, _StatefulGetterSetterMixin], {
        // summary:
        //		Represents the view model for HyperLinkSelector widget.
        //
        // tags:
        //      internal

        _setProvidersAttr: function (providers) {
            var wrapperSettings = [];

            array.forEach(providers, lang.hitch(this, function (provider) {
                wrapperSettings.push({
                    name: provider.name,
                    displayName: provider.displayName ? provider.displayName : provider.name,
                    title: provider.title ? provider.title : "",
                    groupname: "hyperLink_",
                    widgetType: provider.widgetType,
                    invisible: provider.invisible,
                    settings: {
                        roots: provider.roots,
                        allowedTypes: provider.linkableTypes,
                        isContentLink: (provider.linkableTypes && provider.linkableTypes.length > 0),
                        allowedDndTypes: [],
                        disabled: true, // Disable all link input as default
                        value: null
                    }
                });
            }));

            this.set("wrapperSettings", wrapperSettings);
        },

        getContentData: function (value) {
            if (value) {
                return PermanentLinkHelper.getContent(value, { "allLanguages": true });
            }

            return null;
        },

        isBaseTypeIdentifier: function (type, base) {
            return TypeDescriptorManager.isBaseTypeIdentifier(type, base);
        }
    });
});