define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect"
], function(declare, lang, aspect) {

    return declare([], {
        // tags:
        //      internal

        postCreate: function() {
            this.inherited(arguments);

            // Reset the focus node after the grid is updated. This is a bug in dgrid: https://github.com/SitePen/dgrid/issues/899
            this._listeners.push(aspect.around(this, "_restoreFocus", function(originalMethod) {
                return function(row) {
                    var focusInfo = this._removedFocus;

                    originalMethod.apply(this, arguments);

                    if (!this._focusedNode) {
                        row = row && this.row(row);
                        var newTarget = row && row.element && row.id === focusInfo.rowId ? row :
                            typeof focusInfo.siblingId !== "undefined" && this.row(focusInfo.siblingId);

                        if (newTarget) {
                            this._focusedNode = newTarget.element;
                        }
                    }
                };
            }));
        },

        isFocusable: function() {
            // summary:
            //      Indicates whether this grid can currently be focused.
            // tags:
            //      public
            return !!this._focusedNode;
        },

        focus: function(element) {
            // summary:
            //      Set focus to the content of the grid.
            // tags:
            //      public
            if (!element || typeof element == "string") {
                element = this._focusedNode || this.contentNode;
            }
            this.inherited(arguments, [element]);
        }
    });
});
