﻿define([
"dojo/_base/declare",
"dojo/dom-style",
"epi/shell/layout/SimpleContainer"],

function (declare, domStyle, SimpleContainer) {

    return declare([SimpleContainer], {
        // summary:
        //     Widget that contains a group form items widgets, aimed to apply the html formatting specific to a group
        //
        // tags:
        //      internal

        templateString: "<div class='epi-containerLayout clearfix'>\
                            <h3 data-dojo-attach-point='labelNode'>${label}</h3>\
                            <ul data-dojo-attach-point='containerNode'></ul>\
                        </div>",
        postMixInProperties: function () {
            this.inherited(arguments);

            //Get the label text from the title and delete it, otherwise it will be set on the DOM node and result in unwanted tooltips
            this.label = this.title;
            delete this.title;
        },

        postCreate: function () {
            this.inherited(arguments);

            if (!this.label && this.labelNode) {
                domStyle.set(this.labelNode, "display", "none");
            }
        }
    });
});