﻿define([
    "dojo/_base/declare",
    "dijit/Menu",
        
    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/MenuBuilder",
        
    "epi/shell/command/builder/MenuWithSeparatorBuilder"
], function (
    declare,
    Menu,
    
    _CommandConsumerMixin,
    MenuAssembler,
    MenuBuilder,
    MenuWithSeparatorBuilder
) {

    return declare([Menu, _CommandConsumerMixin], {
        // summary:
        //      A context menu that can display context commands for an item.
        //
        // tags:
        //      public

        // category: string
        //		If set the menu will be filtered on the category.
        category: null,

        // leftClickToOpen: [readonly] Boolean
        //		Menu will open on left click instead of right click.
        leftClickToOpen: true,

        postCreate: function () {

            this.inherited(arguments);

            var defaultConfiguration = { builder: new MenuBuilder(), target: this, category: this.category },
                configuration,
                assembler;

            configuration = [defaultConfiguration, { builder: new MenuWithSeparatorBuilder(), target: this, category: "menuWithSeparator" }, { builder: new MenuBuilder(), target: this, category: "popup" }],
            assembler = new MenuAssembler({ configuration: configuration, commandSource: this });

            assembler.build();
        },

        scheduleOpen: function (/*DomNode?*/target, /*DomNode?*/iframe, /*Object?*/coords) {
            // summary:
            //      Display the menu
            // remarks:
            //      See more details in the base class(Dijit/Menu)
            // tags:
            //      public

            this._scheduleOpen(target, iframe, coords);
        }
    });
});
